# Overview

AutoCert provides automated certificate renewal. For more information about
AutoCert itself, see [the Launchpad project page](https://launchpad.net/autocert).

This charm is a subordinate that can be configured to connect to an AutoCert
server to retrieve certificates.

# Usage

Deploy an apache2 charm with a relation to autocert:

    juju deploy cs:apache2
    juju deploy cs:nrpe
    juju deploy cs:~autocert-charmers/autocert
    # Configure to connect to your autocert server
    juju config autocert autocert_host=autocert.example.com
    # Configure for apache2
    juju config autocert chain_required=true
    juju config autocert service_action=restart
    juju config autocert service_name=apache2
    juju config autocert service_test_cmd="/usr/sbin/apache2ctl configtest"
    # Configure your certificates (these should be considered secrets)
    juju config autocert cert_auth_pairs="${CN}=${CN_TOKEN}"
    # For services with multiple SSL certificates
    juju config autocert cert_auth_pairs="${CN1}=${CN1_TOKEN},${CN2}=${CN2_TOKEN},${CN3}=${CN3_TOKEN}"
    # Finally add relations to enable autocert for apache2, and create
    # nagios check for autocert.
    juju add-relation apache2 autocert
    juju add-relation nrpe autocert

You would then configure apache2 to use the certificates that AutoCert manages
renewals for. This typically means having a stanza in your https vhost
template as follows (where the locations match the name of the certificate
AutoCert is managing):

    SSLEngine On
    SSLCertificateFile /etc/ssl/certs/{{ ssl_certlocation }}
    SSLCertificateKeyFile /etc/ssl/private/{{ ssl_keylocation }}
    SSLCertificateChainFile /etc/ssl/certs/{{ ssl_chainlocation }}
